// ##### ENDFILE "ShowWindowEventWrap.h"


// ##### BEGINFILE "NATRedirectEventWrap.h"
/** @file
 * VirtualBox API class wrapper header for INATRedirectEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#ifndef NATRedirectEventWrap_H_
#define NATRedirectEventWrap_H_

#include "VirtualBoxBase.h"
#include "Wrapper.h"

class ATL_NO_VTABLE NATRedirectEventWrap:
    public VirtualBoxBase,
    VBOX_SCRIPTABLE_IMPL(INATRedirectEvent)
{
    Q_OBJECT

public:
    VIRTUALBOXBASE_ADD_ERRORINFO_SUPPORT(NATRedirectEventWrap, INATRedirectEvent)
    DECLARE_NOT_AGGREGATABLE(NATRedirectEventWrap)
    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(NATRedirectEventWrap)
        COM_INTERFACE_ENTRY(ISupportErrorInfo)
        COM_INTERFACE_ENTRY(INATRedirectEvent)
        COM_INTERFACE_ENTRY(IMachineEvent)
        COM_INTERFACE_ENTRY(IEvent)
        COM_INTERFACE_ENTRY2(IDispatch, INATRedirectEvent)
        VBOX_TWEAK_INTERFACE_ENTRY(INATRedirectEvent)
    END_COM_MAP()

    DECLARE_EMPTY_CTOR_DTOR(NATRedirectEventWrap)

    // public IEvent properties
    STDMETHOD(COMGETTER(Type))(VBoxEventType_T *aType);
    STDMETHOD(COMGETTER(Source))(IEventSource **aSource);
    STDMETHOD(COMGETTER(Waitable))(BOOL *aWaitable);

    // public IMachineEvent properties
    STDMETHOD(COMGETTER(MachineId))(BSTR *aMachineId);

    // public INATRedirectEvent properties
    STDMETHOD(COMGETTER(Slot))(ULONG *aSlot);
    STDMETHOD(COMGETTER(Remove))(BOOL *aRemove);
    STDMETHOD(COMGETTER(Name))(BSTR *aName);
    STDMETHOD(COMGETTER(Proto))(NATProtocol_T *aProto);
    STDMETHOD(COMGETTER(HostIP))(BSTR *aHostIP);
    STDMETHOD(COMGETTER(HostPort))(LONG *aHostPort);
    STDMETHOD(COMGETTER(GuestIP))(BSTR *aGuestIP);
    STDMETHOD(COMGETTER(GuestPort))(LONG *aGuestPort);

    // public IEvent methods
    STDMETHOD(SetProcessed)();
    STDMETHOD(WaitProcessed)(LONG aTimeout,
                             BOOL *aResult);

    // public IMachineEvent methods

    // public INATRedirectEvent methods

private:
    // wrapped IEvent properties
    virtual HRESULT getType(VBoxEventType_T *aType) = 0;
    virtual HRESULT getSource(ComPtr<IEventSource> &aSource) = 0;
    virtual HRESULT getWaitable(BOOL *aWaitable) = 0;

    // wrapped IMachineEvent properties
    virtual HRESULT getMachineId(com::Guid &aMachineId) = 0;

    // wrapped INATRedirectEvent properties
    virtual HRESULT getSlot(ULONG *aSlot) = 0;
    virtual HRESULT getRemove(BOOL *aRemove) = 0;
    virtual HRESULT getName(com::Utf8Str &aName) = 0;
    virtual HRESULT getProto(NATProtocol_T *aProto) = 0;
    virtual HRESULT getHostIP(com::Utf8Str &aHostIP) = 0;
    virtual HRESULT getHostPort(LONG *aHostPort) = 0;
    virtual HRESULT getGuestIP(com::Utf8Str &aGuestIP) = 0;
    virtual HRESULT getGuestPort(LONG *aGuestPort) = 0;

    // wrapped IEvent methods
    virtual HRESULT setProcessed() = 0;
    virtual HRESULT waitProcessed(LONG aTimeout,
                                  BOOL *aResult) = 0;

    // wrapped IMachineEvent methods

    // wrapped INATRedirectEvent methods

private:
    DECLARE_CLS_COPY_CTOR_ASSIGN_NOOP(NATRedirectEventWrap); /* Shuts up MSC warning C4625. */

};

#endif // !NATRedirectEventWrap_H_

